## ros-melodic-towr 1.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
project(towr VERSION 1.3.2)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
find_package(ifopt 2.0.1 REQUIRED)


###########
## Build ##
###########
IF(NOT CMAKE_BUILD_TYPE MATCHES Release)
  message(STATUS "CMAKE_BUILD_TYPE not set to Release -> impacts performance")
endif()

# so dynamic library libtowr.so retains link to ifopt_core.so
set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib)

# The motion-planning problem formulated through variables and constraints
add_library(${PROJECT_NAME} SHARED
  # sample formulation usage
  src/nlp_formulation.cc
  src/parameters.cc
  # variables
  src/nodes_variables.cc
  src/nodes_variables_all.cc
  src/nodes_variables_phase_based.cc
  src/phase_durations.cc
  # models
  src/robot_model.cc
  src/dynamic_model.cc
  src/single_rigid_body_dynamics.cc
  # constraints
  src/time_discretization_constraint.cc
  src/base_motion_constraint.cc
  src/terrain_constraint.cc
  src/swing_constraint.cc
  src/force_constraint.cc
  src/total_duration_constraint.cc
  src/dynamic_constraint.cc
  src/range_of_motion_constraint.cc
  src/spline_acc_constraint.cc
  src/linear_constraint.cc
  # costs
  src/node_cost.cc
  src/soft_constraint.cc
  # initialization
  src/gait_generator.cc
  src/monoped_gait_generator.cc
  src/biped_gait_generator.cc
  src/quadruped_gait_generator.cc
  # terrain
  src/height_map_examples.cc
  src/height_map.cc
  # helpers
  src/state.cc
  src/polynomial.cc
  src/spline.cc
  src/phase_spline.cc
  src/node_spline.cc
  src/nodes_observer.cc
  src/spline_holder.cc
  src/euler_converter.cc
  src/phase_durations_observer.cc
)
target_link_libraries(${PROJECT_NAME} 
  PUBLIC 
    ifopt::ifopt_core
)
target_include_directories(${PROJECT_NAME} 
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)


#############
## Testing ##
#############
enable_testing()
# example problem solved with IPOPT
add_executable(${PROJECT_NAME}-example 
  test/hopper_example.cc
)
target_link_libraries(${PROJECT_NAME}-example  
  PRIVATE
    ${PROJECT_NAME} 
    ifopt::ifopt_ipopt
)
add_test(${PROJECT_NAME}-example ${PROJECT_NAME}-example)

# unit tests of costs/constraints
find_package(GTest QUIET)
if (TARGET GTest::GTest) # only build when modern targets exists

  add_executable(${PROJECT_NAME}-test
    test/dynamic_constraint_test.cc
    test/dynamic_model_test.cc
  )
  target_link_libraries(${PROJECT_NAME}-test
    PRIVATE
      ${PROJECT_NAME}
      GTest::GTest GTest::Main
  )
  add_test(${PROJECT_NAME}-test ${PROJECT_NAME}-test)
endif()


#############
## Install ##
#############
include(GNUInstallDirs) # for correct libraries locations across platforms
set(config_package_location "share/${PROJECT_NAME}/cmake") # for .cmake find-scripts installs
install(
  TARGETS ${PROJECT_NAME} ${PROJECT_NAME}-example 
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/towr
)
# Copy header files
install(
  DIRECTORY include/towr/
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/towr
)
# Auto generate and install the find scripts helpers
install(
  EXPORT ${PROJECT_NAME}-targets
  FILE ${PROJECT_NAME}-targets.cmake
  NAMESPACE towr::
  DESTINATION ${config_package_location}
)
# generate the file TowrConfigVersion.cmake
set(version_file "${CMAKE_CURRENT_BINARY_DIR}/towr-config-version.cmake")
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${version_file}
  VERSION ${towr_VERSION}
  COMPATIBILITY SameMajorVersion
)
# install the two files in a place where cmake looks for them
install(
  FILES 
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/towr-config.cmake"   # self-written
    ${version_file}                                         # generated
  DESTINATION ${config_package_location}
)
# Install a Catkin 'package.xml' file. This is required by REP-136.
install(FILES package.xml DESTINATION share/${PROJECT_NAME})

=== debian/changelog ===
ros-melodic-towr (1.4.1-0stretch) stretch; urgency=high

  * Merge pull request (#56 <https://github.com/ethz-adrl/towr/issues/56>) from ethz-adrl/expose-params
  * add explanation for assert in phase_durations
  * Merge branch 'sweetie-bot-project-feat/access-optimization-parameteres' into expose-params
  * Optimize GetPhaseDurations(). Remove unnecessary GetNormalizedPhaseDurations().
  * Make GaitGenerator::SetGaits() method public.
  * Move default parameter values to header.
  * Use pair<double,double> instead of array<double,2> to store bounds.
  * Expose contstraints and costs field to user. Remove unnecessary private functions.
  * Add missing underscore postfix for bounds_final variables.
  * Take into account weights of the costs. (#51 <https://github.com/ethz-adrl/towr/issues/51>)
  * Contributors: Alexander Winkler, Mathieu Geisert, awinkler, disRecord

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Thu, 04 Apr 2019 22:00:00 -0000

ros-melodic-towr (1.4.0-0stretch) stretch; urgency=high

  * Simplify extension / adding own formulation (#38 <https://github.com/ethz-adrl/towr/issues/38>)
  * Facilitate towr_ros user extension (#34 <https://github.com/ethz-adrl/towr/issues/34>)
  * Greatly simplify phase node formulations (#33 <https://github.com/ethz-adrl/towr/issues/33>)
  * keep overview in github readme, not separated into doxygen & github
  * rename CD to SRBD and improve documentation
  * rename nodes to node variables
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Sun, 29 Jul 2018 22:00:00 -0000

ros-melodic-towr (1.3.2-0stretch) stretch; urgency=high

  * adapt to more generic ifopt solver interface.
  * Improve doxygen  (#26 <https://github.com/ethz-adrl/towr/issues/26>)
    * add overview on main doxygen landing
    * add doxygen groups to variables/constraints/costs
    * add parameter explanation
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <alexander.w.winkler@gmail.com>  Mon, 16 Jul 2018 22:00:00 -0000

ros-melodic-towr (1.3.1-0stretch) stretch; urgency=high

  * Improve API (#23 <https://github.com/ethz-adrl/towr/issues/23>)
  * Remove redundant total time (duration set by endeffectors)
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 09 Jul 2018 22:00:00 -0000

ros-melodic-towr (1.3.0-0stretch) stretch; urgency=high

  * add sample gaits for mono-, bi- and quadruped
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Fri, 06 Jul 2018 22:00:00 -0000

ros-melodic-towr (1.2.2-0stretch) stretch; urgency=high

  * remove controller specifc code from towr_ros
  * moved height map from towr_ros to towr
  * moved robots models and gait generator from towr_ros to towr
  * move dynamic and kinematic models from towr_ros -> towr
  * remove all catkin macros from towr::CMakeLists.txt
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 02 Jul 2018 22:00:00 -0000

ros-melodic-towr (1.2.1-0stretch) stretch; urgency=high

  * set parameters for hyq and terrains examples
  * rename constraints and variables for more consistency
  * renamed main library (towr_core -> towr) and removed ros meta package
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Fri, 29 Jun 2018 22:00:00 -0000

ros-melodic-towr (1.2.0-0stretch) stretch; urgency=high

  * allow building with pure cmake (catkin optional)
  * adapt to version 2.0.0 of ifopt (#17 <https://github.com/ethz-adrl/ifopt/pull/17>)
  * add derivative of system dynamics w.r.t angular orientation
  * Improve centroidal dynamics model and add continuous base acceleration constraint
  * Fix final base and footholds through constraint
  * Separate ifopt solver from towr and towr to header+source file
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Sun, 24 Jun 2018 22:00:00 -0000

ros-melodic-towr (1.1.0-0stretch) stretch; urgency=high

  * add metapackage towr and move algorithm to towr_core
  * create separate ros independent example package "towr_ros"
  * replaced ros-keyboard dependency with ncurses
  * moved all robot specific model/gait generators out of towr -> towr_ros
  * use only one unified represenatation for nodes and states
  * remove xpp states dependency
  * added base_nodes class that derives from node_variables
  * add observer pattern (spline observes node_values and contact_schedule)
  * added spline_holder to not always have to reconstruct from variables
  * separated spline and node values
  * adapted to changed ifopt namespace (opt -> ifopt)
  * removed unused variables in polynomial
  * renamed pkg from xpp_opt to towr
  * Contributors: Alexander Winkler

 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 05 Feb 2018 23:00:00 -0000

ros-melodic-towr (1.0.0-0stretch) stretch; urgency=high



 -- Alexander W. Winkler <winklera@ethz.ch>  Mon, 18 Sep 2017 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-towr
Section: misc
Priority: extra
Maintainer: Alexander W. Winkler <alexander.w.winkler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev, ros-melodic-ifopt
Homepage: http://github.com/ethz-adrl/towr
Standards-Version: 3.9.2

Package: ros-melodic-towr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-melodic-catkin, ros-melodic-ifopt
Description: A light-weight, Eigen-based C++ library for trajectory optimization for legged robots.
 This library provides implementations for variables, costs and constraints that can be used to represent a legged locomotion problem. The resulting Nonlinear Programming Problem (NLP) can then be solved with off-the-shelf solvers, e.g. Ipopt using the generic optimizer interface ifopt.
